#include <stdlib.h>
#include <stdio.h>
#include "myBMP.h"

#pragma warning(disable:4996)

unsigned char * createBMP(Bmp bmp)
{
	return (unsigned char *)malloc(3*bmp.width*bmp.height);
};

void setRGB(Bmp bmp,int x, int y, float R, float G, float B)
{	
	char r = (unsigned char) ((R * 255.0f) > 255 ? 255 : R * 255.0f);
	char g = (unsigned char) ((G * 255.0f) > 255 ? 255 : G * 255.0f);
	char b = (unsigned char) ((B * 255.0f) > 255 ? 255 : B * 255.0f);
    
	bmp.img[(x+y*bmp.width)*3+2] = (unsigned char)(r);
	bmp.img[(x+y*bmp.width)*3+1] = (unsigned char)(g);
	bmp.img[(x+y*bmp.width)*3+0] = (unsigned char)(b);
};

void getRGB(Bmp bmp,int x, int y, float &R, float &G, float &B)
{
  R = bmp.img[(x+y*bmp.width)*3+2];
  G = bmp.img[(x+y*bmp.width)*3+1];
  B = bmp.img[(x+y*bmp.width)*3+0];
};


void saveBMP(char *filename, int width, int height, unsigned char * imagedata){

int w = width;

int h = height;

FILE *f;
unsigned char *img = NULL;
int filesize = 54 + 3*w*h;  //w is your image width, h is image height, both int


img = imagedata;

unsigned char bmpfileheader[14] = {'B','M', 0,0,0,0, 0,0, 0,0, 54,0,0,0};
unsigned char bmpinfoheader[40] = {40,0,0,0, 0,0,0,0, 0,0,0,0, 1,0, 24,0};
unsigned char bmppad[3] = {0,0,0};

bmpfileheader[ 2] = (unsigned char)(filesize    );
bmpfileheader[ 3] = (unsigned char)(filesize>> 8);
bmpfileheader[ 4] = (unsigned char)(filesize>>16);
bmpfileheader[ 5] = (unsigned char)(filesize>>24);

bmpinfoheader[ 4] = (unsigned char)(       w    );
bmpinfoheader[ 5] = (unsigned char)(       w>> 8);
bmpinfoheader[ 6] = (unsigned char)(       w>>16);
bmpinfoheader[ 7] = (unsigned char)(       w>>24);
bmpinfoheader[ 8] = (unsigned char)(       h    );
bmpinfoheader[ 9] = (unsigned char)(       h>> 8);
bmpinfoheader[10] = (unsigned char)(       h>>16);
bmpinfoheader[11] = (unsigned char)(       h>>24);

f = fopen(filename, "wb");
fwrite(bmpfileheader,1,14,f);
fwrite(bmpinfoheader,1,40,f);
for(int i=0; i<h; i++)
{
    fwrite(img+(w*(h-i-1)*3),3,w,f);
    fwrite(bmppad,1,(4-(w*3)%4)%4,f);
}
fclose(f);

}


void saveBMP(char *filename, Bmp bmp)
{
	saveBMP(filename, bmp.width, bmp.height, bmp.img);
};

void freeBMP(Bmp bmp)
{
	free(bmp.img);
}